#include<stdio.h>
#include<vector>
using namespace std;

vector<int>p2;

int n,q,a[200001];
int p,k,r;



int main(){

    int br=0;
    bool pr2=true;

    scanf("%d%d",&n,&q);

    p2.push_back(0);

    for(int i=1;i<=n;i++){
        scanf("%d",&a[i]);
        if(a[i]==1)br++;
        if(a[i]==0)br++;
        p2.push_back(p2[i-1]+a[i]);
    }

    if(br==n){
        for(int i=0;i<q;i++){
            scanf("%d%d",&p,&k);
            if(a[p]==a[k] && a[p]==1){
            if((k-p)==(p2[k]-p2[p]))printf("1\n");
            }
            else printf ("0\n" );
            if(i==q-1)return 0;
        }
    }

    for(int i=0;i<q;i++){
        scanf("%d%d",&p,&k);
        r=a[p];
        for(int j=p+1;j<=k;j++,k--)r=r&a[j]&a[k];
        printf("%d\n",r);
    }

    return 0;
}